/* cs_4_ind_rr.c */

#include "head_usycams.h"
#include "def_usycams.h"
#include "objects.h"
#include "def_surfaces.h"



#define EPS 0.0000001

double scp[6*POINTS][2][3];
float  nscp[6*POINTS][2][3];

double tet2, b2, delta, c24, c34, b3, tet3;
double psi, phi, dphi;
int po,tpo;

cs_4_ind_rr()
{
 double alp1,a1,alp3,a3,alp4,a4,l42[2];
 int i,j,k;
 double num,den,den1,dum[3];
 double rcb[3], rct[3], e234[3];
 double dot_prod(),mag_vec();
 double p42[3],e42[3]; 
 double dp43[3],e43[3],de43[3],vec1[3],vec2[3],normal[3],mgn;
 double dva1[3],dva3[3];
 double va1[3],va3[3],va4[3],vz43[3],z43,nuang;
 double bet,d;
 double uvz[3],uvx[3];
 double u[M][3],v[M][3];
 double minus1,minus2;
 double e42i[3],e42f[3],p42i[3],p42f[3];
 float  nu[M][3],nv[M][3];

 a1=vp3_var[0];
 alp1=vp3_var[1];
 a3=vp3_var[2];
 alp3=vp3_var[3];
 a4=vp3_var[4];
 alp4=vp3_var[5];
 l42[0]=vp3_var[6];
 l42[1]=vp3_var[7];

 uvz[0] = 0.;	uvz[1] = 0.;	uvz[2] = 1.;
 uvx[0] = 1.;	uvx[1] = 0.;	uvx[2] = 0.;


 psi  = io[POINTS][0];
 phi  = io[POINTS][1];
 dphi = io[POINTS][2];
 num   = SQR(dphi)-dphi*cos(alp1);
 den   = SQR(dphi)-2*dphi*cos(alp1)+1.;
 b2   = num*a1/den;
 tet2 = atan(dphi*sin(alp1)/((dphi*cos(alp1))-1.));
 bet = alp1-tet2;
 d   = a1-b2;

 num = a3*sin(bet)*(cos(bet)*cos(alp3)-sin(alp3)*sin(bet)*cos(phi))
           - d*sin(alp3);
 den1 = SQR(den)+SQR(sin(bet)*sin(phi));
 slide34[POINTS] = num*sin(phi)/den1;
 
 po = (int)(POINTS/vp4_var[3]);
 tpo = po+M;
 for(i=0;i<=po;i++)
  {
   if(i<=POINTS)
     {
      psi  = io[i][0];
      phi  = io[i][1];
      dphi = io[i][2];
     }
   else
     {
      psi  = 2*io[i-1][0]-io[i-2][0];
      io[i][0]=psi;
      phi  = io[POINTS][1];
      dphi = io[POINTS][2];
     }
   
   num   = SQR(dphi)-dphi*cos(alp1);
   den   = SQR(dphi)-2*dphi*cos(alp1)+1.;
   b2   = num*a1/den;

   tet2 = atan(dphi*sin(alp1)/((dphi*cos(alp1))-1.));
   bet = alp1-tet2;
   d   = a1-b2;

   if(ABS(sin(alp1))>0.00001)
     {
      num = -sin(bet)*sin(phi);
      den = cos(bet)*sin(alp3)+cos(alp3)*sin(bet)*cos(phi);
      nuang  = atan2(num,den);

      if(i<=POINTS)
        {
         num = a3*sin(bet)*(cos(bet)*cos(alp3)-sin(alp3)*sin(bet)*cos(phi))
		- d*sin(alp3);
         den1 = SQR(den)+SQR(sin(bet)*sin(phi));
         z43 = num*sin(phi)/den1; if(i==0) slide34[0]=z43;
        }
      else
         z43 = slide34[POINTS]-(slide34[POINTS]-
		slide34[0])*(i-POINTS)/(double)(po-POINTS);
     }
   else 
     {
      if(ABS(alp1)<0.1)
        {
         num = -d*sin(phi);
         den = a3+d*cos(phi);
         nuang  = atan(num/den);
        }
      else
        {
         num = d*sin(phi);
         den = a3+d*cos(phi);
         nuang  = atan(num/den);
        }
      z43=0.;
     }

   slide34[i] = z43;

/* Begin ------------------------------------- Normal vector --*/
   rot_x(uvz,alp3,dum);
   rot_z(dum,phi,e43);
   rot_x(e43,alp1,dum);
   rot_zt(dum,psi,e43);

   rot_x(uvz,alp3,dum);
   drot_z(dum,phi,vec1);
   rot_x(vec1,alp1,dum);
   rot_zt(dum,psi,vec1);

   rot_x(uvz,alp3,dum);
   rot_z(dum,phi,vec2);
   rot_x(vec2,alp1,dum);
   drot_zt(dum,psi,vec2);

   for(j=0;j<3;j++)
      de43[j]=dphi*vec1[j]+vec2[j];


   drot_zt(uvx,psi,dva1);
   for(j=0;j<3;j++)
      dva1[j] = a1*dva1[j];

   drot_z(uvx,phi,vec1);
   rot_x(vec1,alp1,dum);
   rot_zt(dum,psi,vec1);

   rot_z(uvx,phi,vec2);
   rot_x(vec2,alp1,dum);
   drot_zt(dum,psi,vec2);
   for(j=0;j<3;j++)
      dp43[j] = dva1[j]+a3*(dphi*vec1[j]+vec2[j]);
      
   for(j=0;j<3;j++)
     {
      vec1[j] = dp43[j]+l42[0]*de43[j];
      vec2[j] = dp43[j]+l42[1]*de43[j];
     }
   cross_prod(vec1,e43,dum);
   mgn = mag_vec(dum);
   for(j=0;j<3;j++)
         nsc[i][0][j]= -dum[j]/mgn;

   cross_prod(vec2,e43,dum);
   mgn = mag_vec(dum);
   for(j=0;j<3;j++)
         nsc[i][1][j]= -dum[j]/mgn;
/* End ------------------------------------- Normal vector --*/


   rot_x(uvz,alp4,dum);
   rot_z(dum,nuang,e42);
   rot_x(e42,alp3,dum);
   rot_z(dum,phi,e42);
   rot_x(e42,alp1,dum);
   rot_zt(dum,psi,e42);

   rot_z(uvx,nuang,dum);
   rot_x(dum,alp3,va4);
   rot_z(va4,phi,dum);
   rot_x(dum,alp1,va4);
   rot_zt(va4,psi,dum);
   for(j=0;j<3;j++)
      va4[j] = a4*dum[j];
      
   rot_x(uvz,alp3,dum);
   rot_z(dum,phi,vz43);
   rot_x(vz43,alp1,dum);
   rot_zt(dum,psi,vz43);
   for(j=0;j<3;j++)
      vz43[j] = z43*vz43[j];

   rot_z(uvx,phi,va3);
   rot_x(va3,alp1,dum);
   rot_zt(dum,psi,va3);
   for(j=0;j<3;j++)
      va3[j] = a3*va3[j];

   rot_zt(uvx,psi,va1);
   for(j=0;j<3;j++)
      va1[j] = a1*va1[j];

   for(j=0;j<3;j++)
     {
      p42[j] = va1[j]+va3[j]+vz43[j]+va4[j];
      if(i==0) {p42i[j]=p42[j]; e42i[j]=e42[j];}
      if(i==po){p42f[j]=p42[j]; e42f[j]=e42[j];}
      rcb[j] = p42[j]+l42[0]*e42[j];
      rct[j] = p42[j]+l42[1]*e42[j];
     }


   for(j=0;j<3;j++)
     {
      sc[i][0][j]  = rcb[j];
      sc[i][1][j]  = rct[j];
     }

   cover_surf(p42,e42,l42,u,nu,v,nv);

   for(j=0;j<=CPOINTS;j++)
     {
      for(k=0;k<3;k++)
        {
         uc[i][j][k]  = u[j][k];
         nuc[i][j][k] = nu[j][k];
         v_cam[i][j][k]  = v[j][k];
         nvc[i][j][k] = nv[j][k];
        }
     }
  }
 complement(p42i,e42i,p42f,e42f,l42,po,tpo);
 draw_cam9();
/* draw_camp();*/
 draw_hyp(a4,-alp4,l42);
 draw_foll(a3,l42);
}


complement(p0,e0,pn,en,l,ni,nf)
double p0[3],e0[3],pn[3],en[3],l[2];
int ni,nf;
{
 double xvec[3],zvec[3],eet[3],ee[3],last_e[3],de[3];
 double ept[3],ep[3],last_p[3],ep0[3],epn[3],mgp,mgp0,mgpn,delp,dp[3];
 double last2_p[3],last2_e[3],mgpm2,mgpm1;
 double alpha,talpha,beta,tbeta,vec1[3],vec2[3],dum[3],dum1[3],mgn;
 double mag_vec(), dot_prod();
 double rcb[3],rct[3];
 double u[M][3],v[M][3];
 float  nu[M][3],nv[M][3];
 double mgeex,mgepz,pp[3];
 double mate[3][3],matp[3][3];
 double epx[3],epy[3],epz[3],eex[3],eey[3],eez[3];
 double tau,tau0,taun,deltau,gam,gam0,gamn,delgam;
 double tr1,tr2;
 int    i,j,k,deln;

 xvec[0]=1.;	xvec[1]=0.;	xvec[2]=0.0; 
 zvec[0]=0.;	zvec[1]=0.;	zvec[2]=1.0;

 cartosphe(e0,&tau0,&gam0);
 cartosphe(en,&taun,&gamn);
 delgam=gam0-gamn;
 deltau=tau0-taun;

 mgp0=mag_vec(p0);
 mgpn=mag_vec(pn);
 for(i=0;i<3;i++)
  {
   ep0[i]=p0[i]/mgp0;
   epn[i]=pn[i]/mgpn;
  }
 cross_prod(epn,ep0,dum1);
 mgepz=mag_vec(dum1);
 tbeta=atan2(mgepz,dot_prod(ep0,epn));
 delp=mgpn-mgp0;
 deln=nf-ni;

 for(i=0;i<3;i++)
  {
   epx[i]=epn[i];
   epz[i]=dum1[i]/mgepz;
  }
 cross_prod(epz,epx,epy);

 for(i=0;i<3;i++)
  {
   matp[i][0]=epx[i];
   matp[i][1]=epy[i];
   matp[i][2]=epz[i];
  }
 for(i=0;i<3;i++)
  {
   last2_e[i]=en[i];
   last2_p[i]=pn[i];
  }
 mgpm2=mgpn;
 for(i=1;i<=deln;i++)
  {
   tau  =taun+deltau/(double)deln*i;
   gam  =gamn+delgam/(double)deln*i;
   beta =tbeta/(double)deln*i;
   mgp  =mgpn+(mgp0-mgpn)/(double)deln*i;

   rot_y(zvec,gam,dum);
   rot_z(dum,tau,ee);

   if(ABS(mgpn)>0.000001 && ABS(mgp0)>0.000001)
     {
      rot_z(xvec,beta,ept);
      trans(ept,matp,ep);
     }
   else
     {
      for(j=0;j<3;j++)
         ep[j]=0.;
     }
 /* Begin-----------------------------------normal---*/
    if(i>1)
     {
      for(j=0;j<3;j++)
        {
         de[j]=ee[j]-last2_e[j];
         dp[j]=ep[j]*mgp-last2_p[j];
        }
      for(j=0;j<3;j++)
        {
         last2_e[j]=last_e[j];
         last2_p[j]=last_p[j];
         vec1[j]=dp[j]+l[0]*de[j];
         vec2[j]=dp[j]+l[1]*de[j];
        }
      cross_prod(vec1,last_e,dum);
      mgn=mag_vec(dum);
      for(j=0;j<3;j++)
         nsc[i+ni-1][0][j]= -dum[j]/mgn;
      cross_prod(vec2,last_e,dum);
      mgn=mag_vec(dum);
      for(j=0;j<3;j++)
         nsc[i+ni-1][1][j]= -dum[j]/mgn;
     }

   for(j=0;j<3;j++)
     {
      last_e[j]=ee[j];
      last_p[j]=ep[j]*mgp;
     }
/* End -----------------------------------normal---*/
   for(j=0;j<3;j++)
     {
      pp[j]=ep[j]*mgp;
      rcb[j]=pp[j]+l[0]*ee[j];
      rct[j]=pp[j]+l[1]*ee[j];
     }

   for(j=0;j<3;j++)
     {
      sc[i+ni][0][j]=rcb[j];
      sc[i+ni][1][j]=rct[j];
     }
   cover_surf(pp,ee,l,u,nu,v,nv);

   for(j=0;j<=CPOINTS;j++)
     {
      for(k=0;k<3;k++)
        {
         uc[i+ni][j][k]  = u[j][k];
         nuc[i+ni][j][k] = nu[j][k];
         v_cam[i+ni][j][k]  = v[j][k];
         nvc[i+ni][j][k] = nv[j][k];
        }
     }
  }
 for(j=0;j<3;j++)
  {
   nsc[nf][0][j]= nsc[0][0][j];
   nsc[nf][1][j]= nsc[0][1][j];
  }
}

trans(a,mat,b)
double a[3],mat[3][3],b[3];
{
 b[0]=mat[0][0]*a[0]+mat[0][1]*a[1]+mat[0][2]*a[2];
 b[1]=mat[1][0]*a[0]+mat[1][1]*a[1]+mat[1][2]*a[2];
 b[2]=mat[2][0]*a[0]+mat[2][1]*a[1]+mat[2][2]*a[2];
}

cartosphe(e,tau,gam)
double e[3],*tau,*gam;
{
  *gam = acos(e[2]);
 if(ABS(e[1])<0.00001 && ABS(e[0])<0.00001)
   *tau = 0;
 else
   *tau = atan2(e[1],e[0]);
}

cartopol(p,r,ang)
double p[3],*r,*ang;
{
 *r=sqrt(SQR(p[0])+SQR(p[1]));
 *ang=atan2(p[1],p[0]);
}

 

cover_surf(p,e,l,u,nu,v,nv)
double p[3],e[3],l[2],u[M][3],v[M][3];
float nu[M][3], nv[M][3];
{
 int i,j;
 double eta,gam,tau,dum[3],zvec[3],em[3];

 zvec[0]=0.; zvec[1]=0.; zvec[2]=1.;

 cartosphe(e,&tau,&gam);

 j=0;
 for(eta=0.; eta<=1.; eta=eta+1./CPOINTS)
  {
   rot_y(zvec,eta*gam,dum);
   rot_z(dum,tau,em);
   for(i=0;i<3;i++)
     {
      u[j][i]=eta*p[i]+l[1]*em[i];
      v[j][i]=eta*p[i]+l[0]*em[i];
      nu[j][i]= (float)em[i];
      nv[j][i]= (float)(-em[i]);
     }
   j++;
  }
}

draw_hyp(a,alp,l)
double a, alp, l[2];
{
 double p[3],pr[3],dpr[3],e[3],er[3],der[3],num1[3],num[3],normn;
 int    i,j,k;
 
 p[0] = a;  p[1] = 0.;       p[2] = 0.;
 e[0] = 0.; e[1] = sin(alp); e[2] = cos(alp);

   for (k=0; k<2; k++)
     {
      for (i=0; i<=POINTSF; i++)
       {
         psi = 2*PI/(double)(POINTSF)*i;
         rot_z(p,psi,pr);
         rot_z(e,psi,er);
         drot_z(p,psi,dpr);
         drot_z(e,psi,der);
         for(j=0;j<3;j++)
            num1[j] = dpr[j] + l[k]*der[j];
         cross_prod(num1,e,num);
         normn = sqrt(SQR(num[0]) + SQR(num[1]) + SQR(num[2]));
         for(j=0;j<3;j++)
           {
            sf[i][k][j]  = pr[j]+l[k]*er[j];
            nsf[i][k][j] = (float)(num[j]/normn);
           }
       }
    }
}

draw_cam9()
{
/* double t[200][2][3], b[200][2][3];
 float  nt[200][2][3], nb[200][2][3];*/
 double v1[3],v2[3];
 float  n1[3],n2[3];
 int    i,j,k;


 makeobj(CAM);
          lmbind(MATERIAL,C_CAM); 
   for (k=0; k<1; k++)
     {
      bgnqstrip();
      for (i=0; i<=tpo; i++)
       {
         for(j=0;j<3;j++)
           {
            v1[j]=sc[i][k][j];
            v2[j]=sc[i][k+1][j];
            n1[j]= nsc[i][k][j];
            n2[j]= nsc[i][k+1][j];
           }
         n3f(n1);
         v3d(v1);
         n3f(n1);
         v3d(v2);
       }
      endqstrip();
     }

   for(k=0;k<CPOINTS;k++)
     {
      bgnqstrip();
      for(i=tpo;i>=0;i--)
       {
        for(j=0;j<3;j++)
          {
           v1[j] = uc[i][k][j];
           v2[j] = uc[i][k+1][j];
           n1[j] = nuc[i][k][j];
           n2[j] = nuc[i][k+1][j];
          }
        n3f(n2);
        v3d(v2);
        n3f(n1);
        v3d(v1);
       }
      endqstrip();
     }

   for(k=0;k<CPOINTS;k++)
     {
      bgnqstrip();
/*      for(i=0;i<=tpo;i++)*/
for(i=tpo;i>=0;i--)
       {
        for(j=0;j<3;j++)
          {
           v1[j] = v_cam[i][k][j];
           v2[j] = v_cam[i][k+1][j];
           n1[j] = nvc[i][k][j];
           n2[j] = nvc[i][k+1][j];
          }
        n3f(n2);
        v3d(v2);
        n3f(n1);
        v3d(v1);
       }
      endqstrip();
     }
 closeobj();
}

draw_camp()
{
/* double t[200][2][3], b[200][2][3];
 float  nt[200][2][3], nb[200][2][3];*/
 double v1[3],v2[3];
 float  n1[3],n2[3];
 int    i,j,k;


 makeobj(CAMP);
          lmbind(MATERIAL,C_PINS); 
   for (k=0; k<1; k++)
     {
      bgnqstrip();
      for (i=0; i<=POINTS; i++)
       {
         for(j=0;j<3;j++)
           {
            v1[j]=scp[i][k][j];
            v2[j]=scp[i][k+1][j];
            n1[j]= nscp[i][k][j];
            n2[j]= nscp[i][k+1][j];
           }
         n3f(n1);
         v3d(v1);
         /*n3f(n1);*/
         v3d(v2);
       }
      endqstrip();
     }
 closeobj();
}

draw_foll(a,l)
double a,l[3];
{
/* double t[200][2][3], b[200][2][3];
 float  nt[200][2][3], nb[200][2][3];*/
 double v1[3],v2[3];
 float  n1[3],n2[3];
 int    i,j,k;


 makeobj(ROLLER);
           lmbind(MATERIAL,C_ROLLER); 
   for (k=0; k<1; k++)
     {
      bgnqstrip();
      for (i=0; i<=POINTSF; i++)
       {
         for(j=0;j<3;j++)
           {
            v1[j]=sf[i][k][j];
            v2[j]=sf[i][k+1][j];
            n1[j]= nsf[i][k][j];
            n2[j]= nsf[i][k+1][j];
           }
         n3f(n2);
         v3d(v2);
         n3f(n1);
         v3d(v1);
       }
      endqstrip();
     }
   bgnqstrip();
     for (i=0; i<=POINTSF; i++)
      {
         v1[0] = 0.;
         v1[1] = 0.;
         v1[2] = sf[i][0][2];
         for(j=0;j<3;j++)
            v2[j]=sf[i][0][j];
         n1[0] = 0.; n1[1] = 0.; n1[2] = -1.;
         n3f(n1);
         v3d(v2);
         v3d(v1);
       }
   endqstrip();     
   bgnqstrip();
     for (i=0; i<=POINTSF; i++)
      {
         v1[0] = 0.;
         v1[1] = 0.;
         v1[2] = sf[i][1][2];
         for(j=0;j<3;j++)
            v2[j]=sf[i][1][j];
         n1[0] = 0.; n1[1] = 0.; n1[2] = 1.;
         n3f(n1);
         v3d(v1);
         v3d(v2);
       }
   endqstrip();     
 closeobj();

 makeobj(FOL);
           lmbind(MATERIAL,C_FOL); 
  pushmatrix();
   translate(0.,0.,-.04);
   pipe_fillet(a*.8,a+.08,.08,.03,.03,10);
  popmatrix();
 closeobj();
}





/* 12/III/91 18/III/91 21/III/91 */


/*
   e42[0] = cos(psi)*(cos(phi)*sin(alp4)*sin(nu) 
             + cos(alp4)*sin(alp3)*sin(phi) + 
               cos(alp3)*cos(nu)*sin(alp4)*sin(phi)) + 
               (-(cos(alp3)*cos(alp4)*sin(alp1)) - 
               cos(alp1)*cos(alp4)*cos(phi)*sin(alp3) - 
               cos(alp1)*cos(alp3)*cos(nu)*cos(phi)*sin(alp4) + 
               cos(nu)*sin(alp1)*sin(alp3)*sin(alp4) + 
               cos(alp1)*sin(alp4)*sin(nu)*sin(phi))*sin(psi);

   e42[1] = cos(psi)*(-(cos(alp3)*cos(alp4)*sin(alp1)) - 
               cos(alp1)*cos(alp4)*cos(phi)*sin(alp3) - 
               cos(alp1)*cos(alp3)*cos(nu)*cos(phi)*sin(alp4) + 
               cos(nu)*sin(alp1)*sin(alp3)*sin(alp4) + 
               cos(alp1)*sin(alp4)*sin(nu)*sin(phi)) + 
               (-(cos(phi)*sin(alp4)*sin(nu)) - 
               cos(alp4)*sin(alp3)*sin(phi) - 
               cos(alp3)*cos(nu)*sin(alp4)*sin(phi))*sin(psi);

   e42[2] = cos(alp1)*cos(alp3)*cos(alp4) 
            - cos(alp4)*cos(phi)*sin(alp1)*sin(alp3) - 
              cos(alp3)*cos(nu)*cos(phi)*sin(alp1)*sin(alp4) - 
              cos(alp1)*cos(nu)*sin(alp3)*sin(alp4) + 
              sin(alp1)*sin(alp4)*sin(nu)*sin(phi);


*/

/*
printf("psi=%f tet2=%f nu=%f, z43=%f\n",psi*57.2958,tet2*57.2958,
	nu*57.2958,z43);
*/
