/* screenmode.c */

#include "head_usycams.h"
#include "def_usycams.h"

/* Drawing modes  2D=screen coords */
/**************************************************************
  Switches TO
  2D screen coordinate drawing.
  Assumes that perspective matrix, viewport are defined.
  Restores user to backbuffer and zbuffer modes!!!
**************************************************************/

static Matrix P;
static Matrix MV;


void screen_vp0()
{
 /* Drawing modes 054q
 frontbuffer(TRUE);*/
 zbuffer(FALSE);

 /* Save ModelView matrix */
 mmode(MVIEWING);
 getmatrix(MV);

 /* Save Projection matrix */
 mmode(MPROJECTION);
 getmatrix(P);

 /* Use a screen-coordinate ortho matrix */
 mmode(MSINGLE);
 ortho2(-0.5, XMAX0*scala+.5, -.5,(YMAX2-YMAX0)*scala+.5);
/*printf("xsize=%d ys=%d\n",xsize,ysize);*/

 /* viewport to full screen */
 pushviewport();
 viewport(0, (int)(XMAX0*scala), (int)(YMAX0*scala),(int)(YMAX2*scala));
}
/*----------------------------------------------------------------*/

void screen_vp2()
{
 /* Drawing modes 054q
 frontbuffer(TRUE);*/
 zbuffer(FALSE);

 /* Save ModelView matrix */
 mmode(MVIEWING);
 getmatrix(MV);

 /* Save Projection matrix */
 mmode(MPROJECTION);
 getmatrix(P);

 /* Use a screen-coordinate ortho matrix */
 mmode(MSINGLE);
 ortho2(-0.5, XMAX1*scala+.5, -.5,ysize-(YMAX2*scala)+0.5);


 /* viewport to full screen */
 pushviewport();
 viewport(0, (int)(XMAX1*scala), (int)(YMAX2*scala),ysize);
}
/*----------------------------------------------------------------*/

void screen_vp3()
{
 /* Drawing modes 
 frontbuffer(TRUE);*/
 zbuffer(FALSE);

 /* Save ModelView matrix */
 mmode(MVIEWING);
 getmatrix(MV);

 /* Save Projection matrix */
 mmode(MPROJECTION);
 getmatrix(P);

 /* Use a screen-coordinate ortho matrix */
 mmode(MSINGLE);
 ortho2(-.5,xsize-(XMAX1*scala)+.5, -.5,ysize-(YMAX1*scala)+0.5);


 /* viewport to full screen */
 pushviewport();
 viewport((int)(XMAX1*scala), (int)(xsize), (int)(YMAX1*scala),ysize);
}
/*----------------------------------------------------------------*/

void screen_vp4()
{
 /* Drawing modes 
 frontbuffer(TRUE);*/
 zbuffer(FALSE);

 /* Save ModelView matrix */
 mmode(MVIEWING);
 getmatrix(MV);

 /* Save Projection matrix */
 mmode(MPROJECTION);
 getmatrix(P);

 /* Use a screen-coordinate ortho matrix */
 mmode(MSINGLE);
 ortho2(-.5, xsize-(XMAX1*scala)+.5, -0.5,YMAX1*scala+0.5);


 /* viewport to full screen */
 pushviewport();
 viewport((int)(XMAX1*scala), (int)(xsize), 0,YMAX1*scala);
}
/*----------------------------------------------------------------*/

void screen_vp5()
{
 /* Drawing modes 
 frontbuffer(TRUE);*/
 zbuffer(FALSE);

 /* Save ModelView matrix */
 mmode(MVIEWING);
 getmatrix(MV);

 /* Save Projection matrix */
 mmode(MPROJECTION);
 getmatrix(P);

 /* Use a screen-coordinate ortho matrix */
 mmode(MSINGLE);
 ortho2(-.5, XMAX1*scala+.5, -.5, YMAX0*scala+0.5);

 /* viewport to full screen */
 pushviewport();
 viewport(0, (int)(XMAX1*scala), 0, (int)(YMAX0*scala));
}
/*---------------------------------------------------------------------*/


void exitscreenmode()
{
 /* restore viewport */ 
 popviewport();

 /* restore projection matrix */
 mmode(MPROJECTION);
 loadmatrix(P);

 /* restore viewing matrix */
 mmode(MVIEWING);
 loadmatrix(MV);

 /* restore drawing modes */
 blendfunction(BF_SA, BF_MSA);
 zbuffer(TRUE);
 frontbuffer(FALSE); 
}
/*----------------------------------------------------------------*/


